using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "snore")]
public class Snore : Script, IScriptFailMove, IScriptOnSecondaryEffect
{
    /// <inheritdoc />
    public void FailMove(IExecutingMove move, ref bool fail)
    {
        if (!move.User.HasStatus(ScriptUtils.ResolveName<Status.Sleep>()))
            fail = true;
    }

    /// <inheritdoc />
    public void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        target.Volatile.Add(new FlinchEffect());
    }
}